"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function headerToObject(header) {
  var newHeader = {};

  if (!header) return newHeader;

  for (var headerKey in header) {
    if (typeof header[headerKey] === "function") newHeader[headerKey] = header[headerKey]();else newHeader[headerKey] = header[headerKey];
  };

  return newHeader;
}

function mergeHeaders(mapHeaders, resHeaders, endHeaders, reqHeaders) {
  return _extends({}, headerToObject(mapHeaders), headerToObject(resHeaders), headerToObject(endHeaders), headerToObject(reqHeaders));
}

function mergeOptions(mapOptions, resOptions, endOptions, reqOptions) {
  return _extends({}, mapOptions, resOptions, endOptions, reqOptions);
}

exports.mergeHeaders = mergeHeaders;
exports.mergeOptions = mergeOptions;